import { HttpClient } from '@angular/common/http';
import { Injectable } from '@angular/core';
import { NgxSpinnerService } from 'ngx-spinner';
import { ToastrService } from 'ngx-toastr';
import { AuthServiceService } from './auth-service.service';

@Injectable({
  providedIn: 'root'
})


export class DashboardService {

  constructor(private http: HttpClient, 
    private toastr: ToastrService, 
    private authService: AuthServiceService,
    private spinner: NgxSpinnerService) { }

     //get hospitals list 
     getListData(pageId: number, currentPage: number, dataTableNumber: number){
      this.spinner.show();
      console.log(this.authService.pathApi +'/page_list/' + pageId + '/' + currentPage + '/' + dataTableNumber + '/all');
      return this.http.get(this.authService.pathApi +'/page_list/' + pageId + '/' + currentPage + '/' + dataTableNumber + '/all');
    }
  
     //get data user from searchBar 
     getDataUSerSearchBar(data, pageId, pagenationNumber, dataTableNumber) {
      console.log('url', this.authService.pathApi + '/page_list' + '/' + pageId + '/' + pagenationNumber + '/' + dataTableNumber + '/all/' + data);
       return this.http.get(this.authService.pathApi + '/page_list' + '/' + pageId + '/' + pagenationNumber + '/' + dataTableNumber + '/all/' + data);
    }
  
    //addEvent
    addItem(data, addType) {
      if(addType == 'advertisiment'){
        return this.http.post(this.authService.pathApi + '/add_main_ad' , data);
      } else if(addType == 'internalHospital') {
        return this.http.post(this.authService.pathApi + '/add_hospitals_centers' , data);
      } else if(addType == 'externalHospital') {
        return this.http.post(this.authService.pathApi + '/add_hospitals_centers_ex' , data);
      } else if(addType == 'internalManagement') {
        return this.http.post(this.authService.pathApi + '/add_management' , data);
      } else if(addType == 'externalManagement') {
        return this.http.post(this.authService.pathApi + '/add_management_ex' , data);
      } else if(addType == 'internalMainMenu') {
        return this.http.post(this.authService.pathApi + '/add_menu' , data);
      } else if(addType == 'externalMainMenu') {
        return this.http.post(this.authService.pathApi + '/add_external_menu' , data);
      } else if(addType == 'internalServiceExternalPage') {
        return this.http.post(this.authService.pathApi + '/add_external_service' , data);
      } else if(addType == 'externalServiceExternalPage') {
        return this.http.post(this.authService.pathApi + '/add_external_service_ex' , data);
      } else if(addType == 'internalNews') {
        return this.http.post(this.authService.pathApi + '/add_report' , data);
      } else if(addType == 'externalNews') {
        return this.http.post(this.authService.pathApi + '/add_report_ex' , data);
      } else if(addType == 'internalFooter') {
        return this.http.post(this.authService.pathApi + '/add_footer' , data);
      } else if(addType == 'externalFooter') {
        return this.http.post(this.authService.pathApi + '/add_footer_ex' , data);
      }
    }
  
    //edit event
    editItem(editId,dataEdit,editPageName){
      const editData = dataEdit;
      console.log(editId);
      console.log(editPageName);
      editData['id'] = editId;
      console.log(dataEdit);

      if(editPageName == 'advertisiment') {
        return this.http.post(this.authService.pathApi + '/edit_main_ad', editData);
      } else if(editPageName == 'internalHospital') {
        return this.http.post(this.authService.pathApi + '/edit_hospitals_centers', editData);
      } else if(editPageName == 'externalHospital') {
        return this.http.post(this.authService.pathApi + '/edit_hospitals_centers_ex', editData);
      } else if(editPageName == 'internalManagement') {
        return this.http.post(this.authService.pathApi + '/edit_management' , dataEdit);
      } else if(editPageName == 'externalManagement') {
        return this.http.post(this.authService.pathApi + '/edit_management_ex' , dataEdit);
      } else if(editPageName == 'internalMenu') {
        return this.http.post(this.authService.pathApi + '/edit_menu' , dataEdit);
      } else if(editPageName == 'externalMenu') {
        return this.http.post(this.authService.pathApi + '/edit_external_menu' , dataEdit);
      } else if(editPageName == 'internalServiceExternalPage') {
        return this.http.post(this.authService.pathApi + '/edit_external_service' , dataEdit);
      } else if(editPageName == 'externalServiceExternalPage') {
        return this.http.post(this.authService.pathApi + '/edit_external_service_ex' , dataEdit);
      } else if(editPageName == 'internalNew') {
        return this.http.post(this.authService.pathApi + '/edit_report' , dataEdit);
      } else if(editPageName == 'externalNew') {
        return this.http.post(this.authService.pathApi + '/edit_report_ex' , dataEdit);
      } else if(editPageName == 'internalFooter') {
        return this.http.post(this.authService.pathApi + '/edit_footer', dataEdit);
      } else if(editPageName == 'externalFooter') {
        return this.http.post(this.authService.pathApi + '/edit_footer_ex', dataEdit);
      }
    }
  
    //get event data
    getItemData(pageId: number, typeGetData:string) {
      console.log('wwwwwwwwwwwwwwwwwwwwwwwwwwww', pageId);
      if(typeGetData == 'advertisiment') {
        return this.http.get(this.authService.pathApi + '/get_main_ad/' + pageId);
      } else if(typeGetData == 'hospital') {
        return this.http.get(this.authService.pathApi + '/get_hospitals_centers/' + pageId);
      } else if(typeGetData == 'managament') {
        return this.http.get(this.authService.pathApi + '/get_management/' + pageId);
      } else if(typeGetData == 'mainMenu') {
        return this.http.get(this.authService.pathApi + '/get_menu/' + pageId);
      } else if(typeGetData == 'externalService') {
        return this.http.get(this.authService.pathApi + '/get_external_service/' + pageId);
      } else if(typeGetData == 'news') {
        return this.http.get(this.authService.pathApi + '/get_report/' + pageId);
      } else if(typeGetData == 'footer') {
        return this.http.get(this.authService.pathApi + '/get_footer/' + pageId);
      }
  }
  
    //delete event 
    deleteItem(dataIds, pageId) {
      
      console.log(dataIds);
      console.log(pageId);

      if(pageId == 24) {
        return this.http.post(this.authService.pathApi + '/delete_main_ads' , {'ads_id' : dataIds});
      } else if(pageId == 10) {
        return this.http.post(this.authService.pathApi + '/delete_managements' , {'managements_id' : dataIds});
      } else if(pageId == 31) {
        return this.http.post(this.authService.pathApi + '/delete_managements_ex' , {'managements_id' : dataIds});
      } else if(pageId == 6) {
        return this.http.post(this.authService.pathApi + '/delete_hospitals_centers' , {'hospitals_centers_id' : dataIds});
      } else if(pageId == 30) {
        return this.http.post(this.authService.pathApi + '/delete_hospitals_centers_ex' , {'hospitals_centers_id' : dataIds});
      } else if(pageId == 17) {
        return this.http.post(this.authService.pathApi + '/delete_menus' , {'menus_id' : dataIds});
      } else if(pageId == 18) {
        return this.http.post(this.authService.pathApi + '/delete_external_menus' , {'menus_id' : dataIds});
      } else if(pageId == 19) {
        return this.http.post(this.authService.pathApi + '/delete_external_services_ex' , {'external_services_id' : dataIds});
      } else if(pageId == 7) {
        return this.http.post(this.authService.pathApi + '/delete_external_services' , {'external_services_id' : dataIds});
      } else if(pageId == 20) {
        return this.http.post(this.authService.pathApi + '/delete_reports_ex' , {'reports_id' : dataIds});
      } else if(pageId == 13) {
        return this.http.post(this.authService.pathApi + '/delete_reports' , {'reports_id' : dataIds});
      } else if(pageId == 16) {
        return this.http.post(this.authService.pathApi + '/delete_footers' , {'footers_id' : dataIds});
      } else if(pageId == 29) {
        return this.http.post(this.authService.pathApi + '/delete_footers_ex' , {'footers_id' : dataIds});
      }
    
    };


}
